Subject: Re: [take24 0/6] kevent: Generic event handling mechanism.

From: Evgeniy Polyakov <[email-masked]>
Date: Mon, 20 Nov 2006 11:51:59 +0300

On Mon, Nov 20, 2006 at 12:43:01AM -0800, Andrew Morton ([email-masked]) wrote:
> > > >If thread calls kevent_wait() it means it has processed previous entries, 
> > > >one can call kevent_wait() with $num parameter as zero, which
> > > >means that thread does not want any new events, so nothing will be
> > > >copied.
> > > 
> > > This doesn't solve the problem.  You could only request new events when 
> > > all previously reported events are processed.  Plus: how do you report 
> > > events if the you don't allow get_event pass them on?
> > 
> > Userspace should itself maintain order and possibility to get event in
> > this implementation, kernel just returns events which were requested.
> 
> That would mean that in a multithreaded application (or multi-processes
> sharing the same MAP_SHARED ringbuffer), all threads/processes will be
> slowed down to wait for the slowest one.

Not at all - all other threads can call kevent_get_events() with theirs
own place in the ring buffer, so while one of them is processing an
entry, others can fill next entries.

> > > >They all already imeplemented. Just all above, and it was done several
> > > >months ago already. No need to reinvent what is already there.
> > > >Even if we will decide to remove kevent_get_events() in favour of ring
> > > >buffer-only implementation, winting-for-event syscall will be
> > > >essentially kevent_get_events() without pointer to the place where to
> > > >put events.
> > > 
> > > Right, but this limitation of the interface is important.  It means the 
> > > interface of the kernel is smaller: fewer possibilities for problems and 
> > > fewer constraints if in future something should be changed (and smaller 
> > > kernel).
> > 
> > Ok, lets see for ring buffer implementation right now, and then we will
> > decide if we want to remove or to stay with kevent_get_events() syscall.
> 
> I agree that kevent_get_events() is duplicative and we shouldn't need it. 
> Better to concentrate all our development effort on the single and most
> flexible means of delivery.

Let's wait for ring buffer imeplementation first :)

-- 
	Evgeniy Polyakov